package jugs.javafx.a_basics;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.text.Text;
import javafx.stage.Stage;


/**
 * Beispielprogramm für JavaFX-Schulung
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */

//-fx-font: 48px "Serif";
//-fx-padding: 10;
//-fx-background-color: #CCFF99;
//-fx-text-fill: red;
// ------------------------
// // Auf Text wirkt fats kein Styling
//-fx-font: bold italic 100px Tahoma;
//-fx-fill: linear-gradient(from 0% 0% to 100% 200%, repeat, aqua 0%, red 50%);
//-fx-stroke: black;
//-fx-stroke-width: 7;
//------------------------
//-fx-font: bold italic 20pt "Arial";
//-fx-text-fill: orange;
//-fx-background-color: radial-gradient(radius 100%, derive(-fx-base,20%), derive(-fx-base,-20%));
//-fx-effect: dropshadow( one-pass-box , black , 8 , 0.0 , 2 , 0 );
// -------------------------
//-fx-background-color: 
//    #a6b5c9,
//    linear-gradient(#303842 0%, #3e5577 20%, #375074 100%),
//    linear-gradient(#768aa5 0%, #849cbb 5%, #5877a2 50%, #486a9a 51%, #4a6c9b 100%);
//-fx-background-insets: 0 0 -1 0,0,1;
//-fx-background-radius: 5,5,4;
//-fx-padding: 7 30 7 30;
//-fx-text-fill: #242d35;
//-fx-font-family: "Helvetica";
//-fx-font-size: 12px;
//-fx-text-fill: white;
// ------------------------------------
//-fx-background-color: 
//    linear-gradient(#686868 0%, #232723 25%, #373837 75%, #757575 100%),
//    linear-gradient(#020b02, #3a3a3a),
//    linear-gradient(#9d9e9d 0%, #6b6a6b 20%, #343534 80%, #242424 100%),
//    linear-gradient(#8a8a8a 0%, #6b6a6b 20%, #343534 80%, #262626 100%),
//    linear-gradient(#777777 0%, #606060 50%, #505250 51%, #2a2b2a 100%);
//-fx-background-insets: 0,1,4,5,6;
//-fx-background-radius: 9,8,5,4,3;
//-fx-padding: 15 30 15 30;
//-fx-font-family: "Helvetica";
//-fx-font-size: 18px;
//-fx-font-weight: bold;
//-fx-text-fill: white;
//-fx-effect: dropshadow( three-pass-box , rgba(255,255,255,0.2) , 1, 0.0 , 0 , 1);

public class Exercise1b_FirstJavaFxExample extends Application {

	final ToggleGroup group = new ToggleGroup();
	final RadioButton rb1 = new RadioButton(" => ");
	final RadioButton rb2 = new RadioButton(" => ");
	final RadioButton rb3 = new RadioButton(" => ");
	final RadioButton rb4 = new RadioButton(" => ");
	
	final Label label = new Label("Label");
	final Text text = new Text("Text");
	final Button button = new Button("Button");	
	final TextField textfield = new TextField("TextField");	
	
	public static void main(final String[] args) {

		launch(Exercise1b_FirstJavaFxExample.class, args);
	}

	@Override
	public void start(final Stage stage) throws Exception {

		// Ähnlich wie JFrame ContentPane, Content aufbauen
		final HBox rootPane = new HBox();
		final Scene scene = new Scene(rootPane, 550, 350);		

		final VBox vboxLeft = createCssInputPane();
		final GridPane gridPane = createCssResultGridPane();

		rootPane.setPadding(new Insets(10));
		rootPane.getChildren().addAll(vboxLeft, gridPane);
		stage.setScene(scene);

		// Titel und Resizable-Eigenschaft setzen
		stage.setTitle("FirstJavaFxExample");
		stage.setResizable(true);

		// Positionierung und Sichtbarkeit
		stage.centerOnScreen();
		stage.show();
	}

    private GridPane createCssResultGridPane()
    {
        rb1.setToggleGroup(group);
		rb1.setSelected(true);
		rb2.setToggleGroup(group);
		rb3.setToggleGroup(group);
		rb4.setToggleGroup(group);
		
		final GridPane gridPane = new GridPane();
		gridPane.setPadding(new Insets(7));  
		gridPane.setHgap(5);
		gridPane.setVgap(5);

		gridPane.add(rb1, 0, 0);
		gridPane.add(rb2, 0, 1);
		gridPane.add(rb3, 0, 2);
		gridPane.add(rb4, 0, 3);
		gridPane.add(label, 1, 0);
		gridPane.add(text, 1, 1);
		gridPane.add(button, 1, 2);
		gridPane.add(textfield, 1, 3);
        return gridPane;
    }

    private VBox createCssInputPane()
    {
        final VBox vboxLeft = new VBox(5);
		vboxLeft.getChildren().add(new Label("CSS:"));
		final TextArea cssEditor = new TextArea();
		cssEditor.setMaxWidth(400);
		vboxLeft.getChildren().add(cssEditor);
		final Button applyBtn = new Button("Apply");
		vboxLeft.getChildren().add(applyBtn);
		applyBtn.setOnAction(e ->
		{
			// TODO
		}
		);
        return vboxLeft;
    }
}
